---

# Get file from Oracle Object Storage by Version

- name: Getting database passwd information
  ansible.builtin.getent:
    database: "passwd"
  no_log: true

- name: Check if oci client installed
  become_user: "{{ get_file_file_owner }}"
  ansible.builtin.stat:
    path: "{{ getent_passwd[get_file_file_owner][4] }}/.oci"
  register: oci_client_exsist
  no_log: true

- name: Install OCI client
  ansible.builtin.include_role:
    name: oci_client
  vars:
    oci_client_user: "{{ get_file_file_owner }}"
    oci_client_group: "{{ get_file_file_owner }}"
  when:
    oci_client_exsist.stat.isdir is not defined

- name: Fix oci ansible module error
  ansible.builtin.file:
    path: /tmp/oci_ansible_module.log
    state: touch
    mode: '0777'

- name: Set search string
  ansible.builtin.set_fact:
    prefix: "{{ get_file_file_type }}/{{ get_file_file_version }}"

- name: Debug
  ansible.builtin.debug:
    msg: "{{ prefix }}"

- name: Find files
  become_user: "{{ get_file_file_owner }}"
  oracle.oci.oci_object_storage_object_facts:
    namespace_name: "{{ oci_object_storage_namespace_file }}"
    prefix: "{{ prefix }}"
    bucket_name: sv
    fields: "name,size"
  register: result

- name: Print result
  ansible.builtin.debug:
    msg: "{{ result }}"

- name: Check find result
  ansible.builtin.debug:
    msg: "Prefix {{ get_file_file_type }}/{{ get_file_file_version }} not found"
  when: "result.objects | length"
  failed_when: "result.objects | length == 0"

# We get two entries - a folder and a file. Choosing a result with a file size greater than zero
- name: Set OOS file vars
  ansible.builtin.set_fact:
    found_file_path: "{{ result | json_query('objects[?size >`0`].name') | first }}"

- name: Print file name
  ansible.builtin.set_fact:
    found_file_name: "{{ found_file_path | basename }}"

- name: Print file dest
  ansible.builtin.set_fact:
    file_dest_path: "{{ get_file_file_dest }}/{{ found_file_name }}"

- ansible.builtin.debug:
    msg: "{{ file_dest_path }}"

- name: Get file from Object Storage
  become_user: "{{ get_file_file_owner }}"
  oracle.oci.oci_object_storage_object:
    namespace_name: "{{ oci_object_storage_namespace_file }}"
    bucket_name: sv
    object_name: "{{ found_file_path }}"
    dest: "{{ file_dest_path }}"
  when: found_file_path is defined
  register: result

- name: Print result debugging information
  ansible.builtin.debug:
    msg: "{{ result }}"
